# All files / src/custom-nodes/unicode-array-nodes UnicodeArrayCallsWrapper.ts

100% Statements 36/36
87.5% Branches 7/8
100% Functions 1/1
100% Lines 36/36

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    1471x

    1x
    1x

    1x

    1x
    1x
    1x
    1x
    1x
    1x

    1x
    1x
    1x
    1x

    1x

    522x

    522x

    522x
    522x
    522x

    522x
    3x

    519x

    33433x

    519x

    519x
    519x

    519x
    502x

    1x

    1x

    1x

    1x

    519x

    519x

    519x

     import 'format-unicorn';

    import { TNodeWithBlockStatement } from '../../types/TNodeWithBlockStatement';
    import { TStatement } from '../../types/TStatement';

    import { IOptions } from '../../interfaces/IOptions';

    import { AppendState } from '../../enums/AppendState';
    import { UnicodeArrayEncoding } from '../../enums/UnicodeArrayEncoding';

    import { NO_CUSTOM_NODES_PRESET } from '../../preset-options/NoCustomNodesPreset';

    import { AtobTemplate } from '../../templates/custom-nodes/AtobTemplate';
    import { Rc4Template } from '../../templates/custom-nodes/Rc4Template';
    import { SelfDefendingTemplate } from '../../templates/custom-nodes/unicode-array-nodes/unicode-array-calls-wrapper/SelfDefendingTemplate';
    import { UnicodeArrayBase64DecodeNodeTemplate } from '../../templates/custom-nodes/unicode-array-nodes/unicode-array-calls-wrapper/UnicodeArrayBase64DecodeNodeTemplate';
    import { UnicodeArrayCallsWrapperTemplate } from '../../templates/custom-nodes/unicode-array-nodes/unicode-array-calls-wrapper/UnicodeArrayCallsWrapperTemplate';
    import { UnicodeArrayRc4DecodeNodeTemplate } from '../../templates/custom-nodes/unicode-array-nodes/unicode-array-calls-wrapper/UnicodeArrayRC4DecodeNodeTemplate';

    import { AbstractCustomNode } from '../AbstractCustomNode';
    import { JavaScriptObfuscator } from '../../JavaScriptObfuscator';
    import { NodeAppender } from '../../NodeAppender';
    import { NodeUtils } from '../../NodeUtils';
    import { UnicodeArray } from '../../UnicodeArray';

    export class UnicodeArrayCallsWrapper extends AbstractCustomNode {
        /**
         * @type {AppendState}
         */
        protected appendState: AppendState = AppendState.AfterObfuscation;

        /**
         * @type {UnicodeArray}
         */
        private unicodeArray: UnicodeArray;

        /**
         * @type {string}
         */
        private unicodeArrayName: string;

        /**
         * @type {string}
         */
        private unicodeArrayCallsWrapperName: string;

        /**
         * @param unicodeArrayCallsWrapperName
         * @param unicodeArrayName
         * @param unicodeArray
         * @param options
         */
        constructor (
            unicodeArrayCallsWrapperName: string,
            unicodeArrayName: string,
            unicodeArray: UnicodeArray,
            options: IOptions
        ) {
            super(options);

            this.unicodeArrayCallsWrapperName = unicodeArrayCallsWrapperName;
            this.unicodeArrayName = unicodeArrayName;
            this.unicodeArray = unicodeArray;
        }

        /**
         * @param blockScopeNode
         */
        public appendNode (blockScopeNode: TNodeWithBlockStatement): void {
            if (!this.unicodeArray.getLength()) {
                return;
            }

            NodeAppender.insertNodeAtIndex(blockScopeNode, this.getNode(), 1);
        }

        /**
         * @returns {string}
         */
        public getNodeIdentifier (): string {
            return this.unicodeArrayCallsWrapperName;
        };

        /**
         * @returns {TStatement[]}
         */
        public getNode (): TStatement[] {
            return super.getNode();
        }

        /**
         * @returns {string}
         */
        protected getDecodeUnicodeArrayTemplate (): string {
            let decodeUnicodeArrayTemplate: string = '',
                selfDefendingCode: string = '';

            if (this.options.selfDefending) {
                selfDefendingCode = SelfDefendingTemplate().formatUnicorn({
                    unicodeArrayCallsWrapperName: this.unicodeArrayCallsWrapperName,
                    unicodeArrayName: this.unicodeArrayName
                });
            }

            switch (this.options.unicodeArrayEncoding) {
                case UnicodeArrayEncoding.base64:
                    decodeUnicodeArrayTemplate = UnicodeArrayBase64DecodeNodeTemplate().formatUnicorn({
                        atobPolyfill: AtobTemplate(),
                        selfDefendingCode,
                        unicodeArrayCallsWrapperName: this.unicodeArrayCallsWrapperName
                    });

                    break;

                case UnicodeArrayEncoding.rc4:
                    decodeUnicodeArrayTemplate = UnicodeArrayRc4DecodeNodeTemplate().formatUnicorn({
                        atobPolyfill: AtobTemplate(),
                        rc4Polyfill: Rc4Template(),
                        selfDefendingCode,
                        unicodeArrayCallsWrapperName: this.unicodeArrayCallsWrapperName
                    });

                    break;
            }

            return decodeUnicodeArrayTemplate;
        }

        /**
         * @returns {TStatement[]}
         */
        protected getNodeStructure (): TStatement[] {
            const decodeNodeTemplate: string = this.getDecodeUnicodeArrayTemplate();

            return NodeUtils.convertCodeToStructure(
                JavaScriptObfuscator.obfuscate(
                    UnicodeArrayCallsWrapperTemplate().formatUnicorn({
                        decodeNodeTemplate,
                        unicodeArrayCallsWrapperName: this.unicodeArrayCallsWrapperName,
                        unicodeArrayName: this.unicodeArrayName
                    }),
                    NO_CUSTOM_NODES_PRESET
                ).getObfuscatedCode()
            );
        }
    }